| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Private Attributes | List of all members
Geometry::Element Class Referenceabstract
Geometry

`#include <geomelement.h>`

Inheritance diagram for Geometry::Element:
[legend]

## Public Member Functions
| Element ()
| Element (const Element &)
virtual | ~Element ()
void | blockCallBacks (bool yn, bool flush=true)
bool | blocksCallBacks () const
virtual IntervalND< float > | boundingBox (bool approx) const
virtual Element * | clone () const =0
virtual Iterator * | createIterator () const =0
virtual uiString | errMsg () const
virtual void | getPosIDs (TypeSet< GeomPosID > &, bool noudf=true) const
virtual Coord3 | getPosition (GeomPosID) const =0
virtual bool | isChanged () const
virtual bool | isDefined (GeomPosID) const =0
Element & | operator= (const Element &)
virtual void | resetChangedFlag ()
virtual bool | setPosition (GeomPosID, const Coord3 &)=0
virtual void | trimUndefParts ()
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()

## Public Attributes
CNotifier< Element, const TypeSet< GeomPosID > * > | movementnotifier
CNotifier< Element, const TypeSet< GeomPosID > * > | nrpositionnotifier

## Protected Member Functions
uiString & | errmsg ()
void | triggerMovement ()
void | triggerMovement (const GeomPosID &)
void | triggerMovement (const TypeSet< GeomPosID > &)
void | triggerNrPosCh ()
void | triggerNrPosCh (const GeomPosID &)
void | triggerNrPosCh (const TypeSet< GeomPosID > &)

## Protected Attributes
bool | blockcbs_ = false
bool | ischanged_ = false
TypeSet< GeomPosID > | movementbuffer_
TypeSet< GeomPosID > | nrposchbuffer_

## Private Attributes
uiString * | errmsg_ = nullptr
Threads::Lock | movementlock_
Threads::Lock | poschglock_

## Additional Inherited Members
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Detailed Description

<>

## Constructor & Destructor Documentation

## ◆ Element() [1/2]

Geometry::Element::Element | ( |  | ) |

## ◆ Element() [2/2]

Geometry::Element::Element | ( | const Element & |  | ) |

## ◆ ~Element()

virtual Geometry::Element::~Element | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ blockCallBacks()

void Geometry::Element::blockCallBacks | ( | bool | yn,
|  | bool | flush = true )

Block callbacks until further notice. If blocked, lists of added/changed positions will accumulate changes, so they can be flushed when the block is turned off.

Parameters

  yn |
  flush | specifies whether a callback with all accumulated changes will be triggered.

## ◆ blocksCallBacks()

bool Geometry::Element::blocksCallBacks | ( |  | ) | const
| inline

## ◆ boundingBox()

virtual IntervalND< float > Geometry::Element::boundingBox | ( | bool | approx | ) | const
| virtual

Reimplemented in Geometry::CubicBezierSurface, and Geometry::CubicBezierCurve.

## ◆ clone()

virtual Element * Geometry::Element::clone | ( |  | ) | const
| pure virtual

Implemented in Geometry::BinIDSurface, Geometry::CubicBezierCurve, Geometry::CubicBezierSurface, Geometry::FaultStickSet, Geometry::Horizon2DLine, Geometry::PolygonSurface, and Geometry::ParametricSurface.

## ◆ createIterator()

virtual Iterator * Geometry::Element::createIterator | ( |  | ) | const
| pure virtual

Implemented in Geometry::ParametricCurve, and Geometry::RowColSurface.

## ◆ errmsg()

uiString & Geometry::Element::errmsg | ( |  | ) |
| protected

## ◆ errMsg()

virtual uiString Geometry::Element::errMsg | ( |  | ) | const
| virtual

## ◆ getPosIDs()

virtual void Geometry::Element::getPosIDs | ( | TypeSet< GeomPosID > & | ,
|  | bool | noudf = true ) const
| virtual

Reimplemented in Geometry::BinIDSurface, Geometry::ParametricCurve, and Geometry::RowColSurface.

## ◆ getPosition()

virtual Coord3 Geometry::Element::getPosition | ( | GeomPosID |  | ) | const
| pure virtual

Implemented in Geometry::Horizon2DLine, Geometry::ParametricSurface, Geometry::RowColSurface, and Geometry::CubicBezierCurve.

## ◆ isChanged()

virtual bool Geometry::Element::isChanged | ( |  | ) | const
| inline virtual

## ◆ isDefined()

virtual bool Geometry::Element::isDefined | ( | GeomPosID |  | ) | const
| pure virtual

Implemented in Geometry::Horizon2DLine, Geometry::ParametricSurface, Geometry::RowColSurface, and Geometry::CubicBezierCurve.

## ◆ operator=()

Element & Geometry::Element::operator= | ( | const Element & |  | ) |

## ◆ resetChangedFlag()

virtual void Geometry::Element::resetChangedFlag | ( |  | ) |
| inline virtual

## ◆ setPosition()

virtual bool Geometry::Element::setPosition | ( | GeomPosID | ,
|  | const Coord3 & | )
| pure virtual

Implemented in Geometry::ParametricSurface, Geometry::RowColSurface, Geometry::Horizon2DLine, and Geometry::CubicBezierCurve.

## ◆ triggerMovement() [1/3]

void Geometry::Element::triggerMovement | ( |  | ) |
| protected

## ◆ triggerMovement() [2/3]

void Geometry::Element::triggerMovement | ( | const GeomPosID & |  | ) |
| protected

## ◆ triggerMovement() [3/3]

void Geometry::Element::triggerMovement | ( | const TypeSet< GeomPosID > & |  | ) |
| protected

## ◆ triggerNrPosCh() [1/3]

void Geometry::Element::triggerNrPosCh | ( |  | ) |
| protected

## ◆ triggerNrPosCh() [2/3]

void Geometry::Element::triggerNrPosCh | ( | const GeomPosID & |  | ) |
| protected

## ◆ triggerNrPosCh() [3/3]

void Geometry::Element::triggerNrPosCh | ( | const TypeSet< GeomPosID > & |  | ) |
| protected

## ◆ trimUndefParts()

virtual void Geometry::Element::trimUndefParts | ( |  | ) |
| inline virtual

Reimplemented in Geometry::Horizon2DLine, and Geometry::ParametricSurface.

## Member Data Documentation

## ◆ blockcbs_

bool Geometry::Element::blockcbs_ = false
| protected

## ◆ errmsg_

uiString* Geometry::Element::errmsg_ = nullptr
| private

## ◆ ischanged_

bool Geometry::Element::ischanged_ = false
| protected

## ◆ movementbuffer_

TypeSet<GeomPosID> Geometry::Element::movementbuffer_
| protected

## ◆ movementlock_

Threads::Lock Geometry::Element::movementlock_
| private

## ◆ movementnotifier

CNotifier<Element,const TypeSet<GeomPosID>*> Geometry::Element::movementnotifier

## ◆ nrposchbuffer_

TypeSet<GeomPosID> Geometry::Element::nrposchbuffer_
| protected

## ◆ nrpositionnotifier

CNotifier<Element,const TypeSet<GeomPosID>*> Geometry::Element::nrpositionnotifier

## ◆ poschglock_

Threads::Lock Geometry::Element::poschglock_
| private

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025